/**
 **	File ......... AccountForm.cpp
 **	Published ....  2004-07-09
 **	Author ....... grymse@alhem.net
**/
/*
Copyright (C) 2004  Anders Hedstrom

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*/
//#include <stdio.h>

#include "IWeb.h"
#include <libibank.h>
#include "AccountForm.h"




AccountForm::AccountForm(Web *w) : BaseForm(w, "AccountForm")
,m_bPass(false)
,m_bEmail(false)
,m_bExists(false)
,m_bName(false)
{
}


AccountForm::~AccountForm()
{
}


void AccountForm::Process()
{
	IWeb *pWeb = static_cast<IWeb *>(GetWeb());
	Database& db = pWeb -> GetDatabase();
	Query q(db);
	char action[200];

	// <input type="submit" name="AccountForm" value="action" ...
	if (!GetForm() -> getvalue( (char *)GetFormName().c_str(), action, 200) || !*action)
	{
		return;
	}
	char sql[1000];
	if (!strcmp(action," Login "))
	{
		sprintf(sql,"select * from account where email='%s' and secret='%s'",
			q.safestr(GetForm() -> getvalue("email")).c_str(),
			q.safestr(GetForm() -> getvalue("secret")).c_str() );
		db::Account account(&db, sql);
		if (account.num)
		{
			long valid = random();
			db::Valid x(&db);
			x.account = account.num;
			x.valid = valid;
			x.save();
			pWeb -> SetUsernum( account.num );
			pWeb -> SetValid( valid );
			pWeb -> SetPage( 3 ); // Forums list
		}
	}
	else
	if (!strcmp(action," Register "))
	{
		std::string email = GetForm() -> getvalue("new_email");
		m_email = email;
		m_name = GetForm() -> getvalue("namn");
		m_show = GetForm() -> getvalue("show_email");
		if (!valid_email(email))
		{
			m_bEmail = true;
			return;
		}
		bool alnum = false;
		for (size_t i = 0; i < m_name.size(); i++)
		{
			if (isalnum(m_name[i]))
			{
				alnum = true;
			}
			else
			if (m_name[i] != ' ')
			{
				m_bName = true;
				return;
			}
		}
		if (!alnum)
		{
			m_bName = true;
			return;
		}
		std::string secret = GetForm() -> getvalue("new_secret");
		if (secret.size() < 4 || secret != GetForm() -> getvalue("new_secret2"))
		{
			m_bPass = true;
			return;
		}
		sprintf(sql,"select * from account where email='%s'",q.safestr(email).c_str());
		db::Account account(&db, sql);
		if (account.num)
		{
			m_bExists = true;
			return;
		}
		account.email = email;
		account.secret = secret;
		account.name = m_name;
		account.show_email = atoi(m_show.c_str());
		account.save();
		// create valid
		if (account.num)
		{
			long valid = random();
			db::Valid x(&db);
			x.account = account.num;
			x.valid = valid;
			x.save();
			pWeb -> SetUsernum( account.num );
			pWeb -> SetValid( valid );
			pWeb -> SetPage( 3 ); // Forums list
		}
	}
}


void AccountForm::Display(long)
{
//	IWeb *pWeb = static_cast<IWeb *>(GetWeb());

	printf("<form action=\"%s\" method=post>",GetCgiName().c_str());
fflush(stdout);
	printf("<h3>Login</h3>");
	printf("<table cellpadding=\"0\" cellspacing=\"0\" class=login>");
	printf("<tr><td class=login>");
	printf("Email<br>");
	printf("<input type=text size=40 name=email><br>");
	printf("</td></tr><tr><td class=login>");
	printf("Password<br>");
	printf("<input type=password name=secret><br>");
	printf("</td></tr><tr><td class=login align=center>");
	printf("<input type=submit name=\"%s\" value=\" Login \"><br>",GetFormName().c_str());
	printf("</td></tr></table>");

	printf("<h3>Register</h3>");
	printf("<table cellpadding=\"0\" cellspacing=\"0\" class=login>");
	printf("<tr><td class=login>");
	if (m_bEmail)
		printf("<font class=error size=\"+2\">Invalid email address</font><br>");
	if (m_bExists)
		printf("<font class=error size=\"+2\">Email address already registrered</font><br>");
	printf("Your email (used for login)<br>");
	printf("<input type=text size=40 name=new_email value=\"%s\"><br>",m_email.c_str());
	printf("</td></tr><tr><td class=login>");
	if (m_bName)
		printf("<font class=error size=\"+2\">Invalid name</font><br>");
	printf("Display name (only letters / digits please)<br>");
	printf("<input type=text size=40 name=namn value=\"%s\"><br>",m_name.c_str());
	printf("</td></tr><tr><td class=login>");
	printf("<input type=checkbox name=show_email value=1%s> Show email address when posting<br>",m_show.size() ? " CHECKED" : "");
	printf("</td></tr><tr><td class=login>");
	if (m_bPass)
		printf("<font class=error size=\"+2\">Bad password</font><br>");
	printf("Password (at least four characters long)<br>");
	printf("<input type=password name=new_secret><br>");
	printf("Please repeat password<br>");
	printf("<input type=password name=new_secret2><br>");
	printf("</td></tr><tr><td class=login align=center>");
	printf("<input type=submit name=\"%s\" value=\" Register \"><br>",GetFormName().c_str());
	printf("</td></tr></table>");

	printf("</form>");
}


