/**
 **	File ......... BaseForm.cpp
 **	Published ....  2004-07-09
 **	Author ....... grymse@alhem.net
**/
/*
Copyright (C) 2004  Anders Hedstrom

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*/
//#include <stdio.h>

#include <mysql/mysql.h>
#include <libmysqlwrapped.h>
#include <libibank.h>
#include "IWeb.h"
#include "BaseForm.h"

/*
#define DEB(x) { \
	FILE *fil = fopen("/tmp/debug","at"); \
	x; \
	fclose(fil); \
}
*/


BaseForm::BaseForm(Web *pWeb,const std::string& x) : WebForm(pWeb,x)
,m_mime("/usr/local/apache/conf/mime.types")
{
}


BaseForm::~BaseForm()
{
}


long BaseForm::AddImage(long num,const std::string &filename)
{
	IWeb *pWeb = static_cast<IWeb *>(GetWeb());
	Database& db = pWeb -> GetDatabase();
	db::Image pic(&db);
	Base64 bomb;
	size_t x = 0;
	size_t y = 0;

	unlink("/tmp/tn.gif");
	unlink("/tmp/geometry");
	{
		FILE *fil;
		char cmd[1000];
		sprintf(cmd,"%s -verbose -geometry 128 %s /tmp/tn.gif 2>/tmp/geometry",_CONVERT,filename.c_str());
		system( cmd );
		if ((fil = fopen("/tmp/geometry", "rt")) != NULL)
		{
			fgets(cmd, 1000, fil);
			{
				cgi::Parse pa(cmd);
				pa.getword(cmd); // file=>file
				{
					pa.getword(); // type
					pa.getword(cmd); // geometry XxY
					{
						cgi::Parse pa(cmd,"x=");
						x = pa.getvalue();
						y = pa.getvalue();
					}
				}
			}
			fclose(fil);
		}
	}
	pic.owner = num;
	bomb.encode_from_file( (char *)filename.c_str(), pic.image_data);
	bomb.encode_from_file( "/tmp/tn.gif", pic.image_tn);
	pic.filename = filename;
	pic.xsize = x;
	pic.ysize = y;
	pic.modified = GetDate();
	pic.save();
	return pic.num;
}


std::string BaseForm::GetMimeFromFilename(const std::string& filename)
{
	std::string tmp;
	size_t x = 0;
	for (size_t i = 0; i < filename.size(); i++)
	{
		if (filename[i] >= 'A' && filename[i] <= 'Z')
			tmp += (char)(filename[i] + 32);
		else
			tmp += filename[i];
		if (filename[i] == '.')
			x = i + 1;
	}
	std::string ext = filename.substr(x);
	return m_mime.GetMimeFromExtension(ext);
}


std::string BaseForm::GetAccountName(db::Account& account)
{
	char slask[1000];
	if (account.show_email && valid_email(account.email))
	{
		sprintf(slask,"<b>%s</b><br>&nbsp;(<a href=\"mailto:%s\">%s</a>)",account.name.c_str(),account.email.c_str(),account.email.c_str());
		return slask;
	}
	sprintf(slask,"<b>%s</b>",account.name.c_str());
	return slask;
}


bool BaseForm::valid_email(const std::string& email)
{
	char *s = strstr(email.c_str(),"@");
	if (s && strstr(s,"."))
		return true;
	return false;
}


void BaseForm::viewtext(const std::string& str,bool in_textarea)
{
	for (size_t i = 0; i < str.size(); i++)
	{
		if (str[i] == 13 && !in_textarea)
		{
		}
		else
		if (str[i] == 10 && !in_textarea)
		{
			printf("<br>");
		}
		else
		if (str[i] == '<')
		{
			printf("&lt;");
		}
		else
		if (str[i] == '&')
		{
			printf("&amp;");
		}
		else
		{
			printf("%c",str[i]);
		}
	}
	if (!in_textarea)
	{
		printf("<br>");
	}
}


void BaseForm::Navigator(long nforum,long nthread,long nmessage)
{
	IWeb *pWeb = static_cast<IWeb *>(GetWeb());
	Database& db = pWeb -> GetDatabase();

	printf("<div class=navigator>");
	printf("<table cellpadding=0 cellspacing=0 width=\"100%%\"><tr><td>");
	if (!nforum)
	{
		printf("<b>Forums</b>");
		return;
	}
	db::Forum forum(db, nforum);
	printf("<a href=\"%s?page=3\">Forums</a>&nbsp;-&nbsp;",GetCgiName().c_str());
	if (!nthread)
	{
		nbprintf("<b>%s</b>",forum.name.c_str());
		return;
	}
	db::Thread thread(db, nthread);
	printf("<a href=\"%s?ForumsForm=select&forum=%ld\">",GetCgiName().c_str(),forum.num);
	nbprintf("%s</a> - ",forum.name.c_str());
	if (!nmessage)
	{
		if (!thread.num)
			thread.title = "&lt;new topic>";
		nbprintf("<b>%s</b>",thread.title.c_str());
		return;
	}
	db::Message message(db, nmessage);
	printf("<a href=\"%s?ThreadListForm=view&thread=%ld\">",GetCgiName().c_str(),thread.num);
	nbprintf("%s</a> - ",thread.title.c_str());
	{
		if (!message.num)
			message.title = "&lt;new message>";
		nbprintf("<b>%s</b>",message.title.c_str());
	}
}


void BaseForm::viewtn(long num)
{
//	IWeb *pWeb = static_cast<IWeb *>(GetWeb());
//	Database& db = pWeb -> GetDatabase();
//	db::Image image(db, num);

/*
	printf("<img");
	printf(" onmouseout=\"return nd();\"");
	printf(" onmouseover=\"return overlib('<img src=%s?img=%ld>');\"", 
		GetCgiName().c_str(), num);
	printf(" border=\"0\" src=\"%s?imgtn=%ld\" alt=\"Thumbnail\">", GetCgiName().c_str(), num);
*/
	printf("<a class=tn href=\"%s?img=%ld\">",GetCgiName().c_str(),num);
	printf("<img border=\"0\" src=\"%s?imgtn=%ld\" alt=\"Thumbnail\">",GetCgiName().c_str(),num);
/*
	printf("<img");
	printf(" onmouseout=\"return nd();\"");
	printf(" onmouseover=\"return overlib('<img src=%s?img=%ld>', WRAP, ABOVE, FOLLOWMOUSE, 0, OFFSETX, 50);\"", 
		GetCgiName().c_str(), num);
	printf(" border=\"0\" src=\"%s?imgtn=%ld\" alt=\"Thumbnail\">", GetCgiName().c_str(), num);
*/
	printf("</a>");
}


